ies = []
ies.append({ "ie_type" : "MEI", "ie_value" : "ME Identity", "presence" : "C", "instance" : "0", "comment" : "If an SGW receives this IE from an MME/SGSN during a TAU/RAU/Handover procedure, the SGW shall forward it across the S5/S8 interface to the PGW."})
ies.append({ "ie_type" : "ULI", "ie_value" : "User Location Information", "presence" : "C", "instance" : "0", "comment" : "The MME/SGSN shall include this IE for the TAU/RAU/Handover procedures if the PGW/PCRF has requested location information change reporting and MME/SGSN support location information change reporting. An MME/SGSN which supports location information change shall include this IE for UE-initiated Service Request and UE initiated Connection Resume procedures if the PGW/PCRF has requested location information change reporting and the UEs location info has changed.See NOTE 5, NOTE 17.The MME shall include the ECGI and/or TAI, or TAI and Macro eNB ID, or Macro eNB ID depending on the Change Reporting Action provided to the MME. The SGSN shall include either the CGI or SAI or RAI, or CGI/SAI together with RAI in the ULI depending on the Change Reporting Action provided to the SGSN.When ISR is active, the MME/SGSN which supports location information change shall include this IE for UE-initiated Service Request procedure, if the PGW/PCRF has requested location information change reporting."})
ies.append({ "ie_type" : "Serving Network", "ie_value" : "Serving Network", "presence" : "CO", "instance" : "0", "comment" : "This IE shall be included on S11/S4 interface during the following procedures: -	TAU/RAU/handover if Serving Network is changed.-	TAU/RAU when the UE was ISR activated which is indicated by ISRAU flag.-	UE triggered Service Request when UE is ISR activated.-	UE initiated Service Request if ISR is not active, but the Serving Network has changed during previous mobility procedures, i.e. intra MME/S4-SGSN TAU/RAU and the change has not been reported to the PGW yet.-	TAU/RAU procedure as part of the optional network triggered service restoration procedure with ISR, as specified by 3GPP TS 23.007 [17]."})
ies.append({ "ie_type" : "RAT Type", "ie_value" : "RAT Type", "presence" : "C", "instance" : "0", "comment" : "This IE shall be sent on the S11 interface for a TAU with a RAT type change, UE triggered Service Request or an I-RAT Handover.This IE shall be sent on the S4 interface for a RAU with MME interaction, a RAU with an SGSN change, a UE Initiated Service Request or an I-RAT Handover.This IE shall be sent on the S5/S8 interface if the RAT type changes."})
ies.append({ "ie_type" : "Indication", "ie_value" : "Indication Flags", "presence" : "C", "instance" : "0", "comment" : "This IE shall be included if any one of the applicable flags is set to 1.Applicable flags are:Idle mode Signalling Reduction Activation Indication: This flag shall be set to 1 on S4/S11 interface, if the ISR is established between the MME and the S4 SGSN.Handover Indication: This flag shall be set to 1 on the S4/S11 and S5/S8 interfaces during a Handover from Trusted or Untrusted Non-3GPP IP Access to E-UTRAN or a Handover from Trusted or Untrusted Non-3GPP IP Access to UTRAN/GERAN procedures.Direct Tunnel Flag: This flag shall be set to 1 on the S4 interface, if Direct Tunnel is used.Change Reporting Support Indication: shall be set to 1 on S4/S11, S5/S8 interfaces, if the SGSN/MME supports location Info Change Reporting and if the SGSN/MMEs operator policy permits reporting of location change to the operator of the PGW with which the session is established. This flag should be ignored by SGW if no message is sent on S5/S8. See NOTE 4.CSG Change Reporting Support Indication: shall be set to 1 on S4/S11, S5/S8, if the SGSN/MME supports CSG Information Change Reporting and if the SGSN/MMEs operator policy permits reporting of the CSG Information change to the operator of the PGW with which the session is established. This flag shall be ignored by SGW if no message is sent on S5/S8. See NOTE 4.Change F-TEID support Indication: This flag shall be set to 1 on S4/S11 for an IDLE state UE initiated TAU/RAU procedure to allow the SGW changing the GTP-U F-TEID. Propagate BBAI Information Change: The MME/SGSN shall set this flag to 1 on S11/S4 in procedures without MME/SGSN change if the PGW has requested H(e)NB information reporting and the H(e)NB local IP address or UDP port number information from H(e)NB in UE associated S1/Iu signalling has changed. (NOTE 8)The MME/SGSN shall set this flag to 1 on S11/S4 during TAU/RAU/Handover with MME/SGSN change procedures if the PGW has requested H(e)NB information reporting.See 3GPP TS 23.139 [51]. CS to PS SRVCC indication: This flag shall be set to 1 on S4/S11 and on S5/S8 during UTRAN/GERAN to E-UTRAN/UTRAN (HSPA) SRVCC procedure as specified in 3GPP TS 23.216 [43].Change of Location Information Indication (CLII): This flag shall be set to 1 on S4/S11 interface only when the ISR is active for the UE. This flag shall be set to 1 by the MME/S4-SGSN if the ULI IE is included in the Modify Bearer Request message and the location information has changed since last reported by the MME/S4-SGSN. See NOTE 9. .PDN Pause Support Indication: this flag shall be set to 1 on the S5/S8 interface during the TAU/RAU/handover with SGW relocation procedures if the new SGW supports the PGW Pause of Charging procedure.PDN Pause On Indication: this flag shall be set to 1 on the S5/S8 interface if the SGW requests the PGW to pause the charging for the PDN connection as specified in 3GPP TS 23.401 [3]. (NOTE 13).PDN Pause Off Indication: this flag shall be set to 1 on the S5/S8 interface if the SGW requests the PGW to unpause the charging for the PDN connection as specified in 3GPP TS 23.401 [3]. (NOTE 13).Change of Presence Reporting Area information Indication (CPRAI): this flag shall be set to 1 on the S4/S11 interface if ISR is active for the UE and if the Presence Reporting Area Information IE is included in the Modify Bearer Request message and the Presence Reporting Area information has changed since last reported by the MME/S4-SGSN. See NOTE 9. P-CSCF Restoration Indication: this flag shall be set to 1 on the S11/S4 and S5/S8 interfaces, for the IMS PDN connection, if the MME/S4-SGSN has received the indication from the HSS that a P-CSCF restoration is required for this user. UE Available for Signalling Indication: this flag shall be set to 1 on S11/S4 by the MME/SGSN during a TAU/RAU or a Service Request procedure for E-UTRAN/UTRAN, or UE initiated Connection Resume procedure for E-UTRAN, or at receipt of an uplink LLC PDU for user data or any valid LLC frame serving as a paging response for GERAN, if the PDN connection is delay tolerant and if there is pending network initiated PDN connection signalling.  The SGW shall include this IE on S5/S8 if it receives the flag from the MME/SGSN. S11-U Tunnel Flag: this flag shall be set to 1 on the S11 interface if user data is transported in NAS signalling.Extended PCO Support Indication: this flag shall be set to 1 on S11 interface by the MME if the UE and the MME support ePCO. This flag shall be set to 1 on S5/S8 interface by the SGW if the SGW support ePCO and the MME has set the flag to 1 over the S11 interface. See NOTE 18.NBIFOM Support Indication: this flag shall be set to 1 on S11/S4 during an inter-PLMN mobility procedure for E-UTRAN/UTRAN if the MME/SGSN supports NBIFOM.This flag shall be set to 1 on S5/S8 during an inter-PLMN mobility procedure for E-UTRAN/UTRAN if both the SGW and the MME/SGSN support NBIFOM.See NOTE 19. eNB Change Reporting Support Indication: shall be set to 1 on S11, S5/S8 interfaces, if the MME supports location Info Change Reporting and if the MMEs operator policy permits reporting of location change to the operator of the PGW with which the session is being established. See NOTE 21.LTE-M RAT Type reporting to PGW Indication: this flag shall be set to 1 on S11, based on operator policy or roaming agreements (for Home Routed PDN connections), if the SGW needs to forward the LTE-M RAT type to the PGW.MTEDTA (MT-EDT Applicable): this flag shall be set to 1 on the S11 interface if MT-EDT is applicable to the PDN connection; MTEDTN (MT-EDT NOT Applicable): this flag shall be set to 1 on the S11 interface if MT-EDT is not applicable to the PDN connection;"})
ies.append({ "ie_type" : "F-TEID", "ie_value" : "Sender F-TEID for Control Plane", "presence" : "C", "instance" : "0", "comment" : "The new MME/SGSN shall include this IE on the S11 and S4 interfaces for a TAU/RAU/ Handover with an MME/SGSN change and without any SGW change. See NOTE 10.If the SGW receives this IE and if it finds that its value is the same as the earlier received value of this IE for this UE, it should interpret this to mean that the MME/SGSN has not changed.The new SGW shall include this IE on the S5 and S8 interfaces for a TAU/RAU/Handover with a SGW change. See NOTE 10.If the PGW receives this IE and if it finds that its value is the same as the earlier received value of this IE for this PDN connection, it should interpret this to mean that the SGW has not changed."})
ies.append({ "ie_type" : "AMBR", "ie_value" : "Aggregate Maximum Bit Rate", "presence" : "C", "instance" : "0", "comment" : "The APN-AMBR shall be sent for TAU/RAU/Handover from the Gn/Gp SGSN to the S4 SGSN/MME procedures."})
ies.append({ "ie_type" : "Delay Value", "ie_value" : "Delay Downlink Packet Notification Request", "presence" : "C", "instance" : "0", "comment" : "his IE shall be sent on the S11 interface for a UE triggered Service Request and UE initiated Connection Resume procedures. It shall contain the delay the SGW shall apply between receiving downlink data and sending Downlink Data Notification for all UEs served by that MME (see clause 5.3.4.2 of 3GPP TS 23.401 [3])."})
ies.append({ "ie_type" : "Bearer Context", "ie_value" : "Bearer Contexts to be modified", "presence" : "C", "instance" : "0", "comment" : "This IE shall be sent on the S4/S11 interface and S5/S8 interface, except on the S5/S8 interface for a UE triggered Service Request and UE initiated Connection Resume procedures. on the S5/S8 interface for a TAU/RAU/HO without SGW change procedure. See NOTE 10. .on the S5/S8 interface when requesting the PGW to pause or unpause charging for the PDN connection. on the S5/S8 interface for any other procedure without SGW change which requires to send a Modify Bearer Request to the PGW, e.g. HSS-based P-CSCF restoration for 3GPP access, reporting of UE presence in a Presence Reporting Area, implicit resume of suspended bearers.(see NOTE 6).When Handover Indication flag is set to 1 (i.e., for a Handover from Trusted or Untrusted Non-3GPP IP Access to E-UTRAN or a Handover from Trusted or Untrusted Non-3GPP IP Access to UTRAN/GERAN procedures), the PGW shall ignore this IE. See NOTE 1.Several IEs with the same type and instance value may be included as necessary to represent a list of Bearers to be modified.During a TAU/RAU/Handover procedure with an SGW change, the SGW includes all bearers it received from the MME/SGSN (Bearer Contexts to be created, or Bearer Contexts to be modified and also Bearer Contexts to be removed) into the list of Bearer Contexts to be modified IEs, which are then sent on the S5/S8 interface to the PGW (see NOTE 2, see NOTE 10). During an E-UTRAN Initiated E-RAB modification procedure the MME shall send a Modify Bearer Request, including all the bearers (those modified and those not modified), per PDN connection for which at least one bearer has changed. See NOTE 11."})
ies.append({ "ie_type" : "Bearer Context", "ie_value" : "Bearer Contexts to be removed", "presence" : "C", "instance" : "1", "comment" : "This IE shall be included on the S4 and S11 interfaces for the TAU/RAU/Handover, UE initiated Connection Resume and Service Request procedures where any of the bearers existing before the TAU/RAU/Handover procedure, UE initiated Connection Resume and Service Request procedures will be deactivated as consequence of the TAU/RAU/Handover procedure, UE initiated Connection Resume and Service Request procedures. See NOTE 3 and NOTE 6.For each of those bearers, an IE with the same type and instance value, shall be included. See NOTE 11."})
ies.append({ "ie_type" : "Recovery", "ie_value" : "Recovery", "presence" : "C", "instance" : "0", "comment" : "This IE shall be included if contacting the peer for the first time "})
ies.append({ "ie_type" : "UE Time Zone", "ie_value" : "UE Time Zone", "presence" : "CO", "instance" : "0", "comment" : "This IE shall be included by the MME/SGSN on the S11/S4 interfaces if the UE Time Zone has changed in the case of TAU/RAU/Handover or UE initiated Service Request procedure. See NOTE 5."})
ies.append({ "ie_type" : "FQ-CSID", "ie_value" : "MME-FQ-CSID", "presence" : "C", "instance" : "0", "comment" : "This IE shall be included by MME on S11 and shall be forwarded by SGW on S5/S8 according to the requirements in 3GPP TS 23.007 [17]."})
ies.append({ "ie_type" : "UCI", "ie_value" : "User CSG Information", "presence" : "CO", "instance" : "0", "comment" : "The MME/SGSN shall include this IE for Handover procedures, UE initiated Connection Resume and UE-initiated Service Request procedure if the PGW/PCRF has requested CSG Info reporting and the MME/SGSN support the CSG information reporting and the User CSG information has changed (i.e. the UE is accessed via a new CSG cell or hybrid cell or leaves a CSG or hybrid cell).In TAU/RAU procedure without SGW change, this IE shall also be sent if the PGW/PCRF has requested CSG info reporting and MME/SGSN supports CSG info reporting and the User CSG information has changed (i.e. the UE is accessed via a new CSG cell or hybrid cell or leaves a CSG or hybrid cell) when UE requested to activate E-RAB for all the active EPS bearers in TAU procedure or to keep the Iu connection after the completion of the RAU procedure. See NOTE 5. See NOTE 10. See NOTE 16.The SGW shall include this IE on S5/S8 if it receives the User CSG Information from MME/SGSN. See NOTE 15."})
ies.append({ "ie_type" : "IP Address", "ie_value" : "UE Local IP Address", "presence" : "CO", "instance" : "1", "comment" : "If the UE local IP Address has changed, the ePDG shall include this IE on S2b interface based on local policy for Fixed Broadband access network interworking (see 3GPP TS 23.139 [51]). "})
ies.append({ "ie_type" : "Port Number", "ie_value" : "UE UDP Port", "presence" : "CO", "instance" : "1", "comment" : "The ePDG shall include this IE on S2b interface if NAT is detected and UE Local IP Address is present for Fixed Broadband access network interworking (see 3GPP TS 23.139 [51]).  "})
ies.append({ "ie_type" : "LDN", "ie_value" : "MME/S4-SGSN LDN", "presence" : "O", "instance" : "0", "comment" : "This IE is optionally sent by the MME to the SGW on the S11 interface and by the SGSN to the SGW on the S4 interface (see 3GPP TS 32.423 [44]), when communicating the LDN to the peer node for the first time."})
ies.append({ "ie_type" : "LDN", "ie_value" : "SGW LDN", "presence" : "O", "instance" : "1", "comment" : "This IE is optionally sent by the SGW to the PGW on the S5/S8 interfaces (see 3GPP TS 32.423 [44]), for inter-SGW mobity, when communicating the LDN to the peer node for the first time."})
ies.append({ "ie_type" : "IP Address", "ie_value" : "HNB Local IP Address", "presence" : "CO", "instance" : "0", "comment" : "The MME/SGSN shall include this IE on S11/S4 interface if the PGW/PCRF has requested H(e)NB information reporting and the MME/SGSN has received this information from H(e)NB in UE associated S1/Iu signalling (see 3GPP TS 23.139 [51]). The SGW shall forward this IE on S5/S8 interface if it is received from the MME/SGSN and the Modify Bearer Request message needs to be sent to the PGW as specified in the 3GPP TS 23.401 [3]; orthe Propagate BBAI information change flag is received from the MME/SGSN.(NOTE 7)"})
ies.append({ "ie_type" : "Port Number", "ie_value" : "HNB UDP Port", "presence" : "CO", "instance" : "0", "comment" : "The MME/SGSN shall include this IE on S11/S4 interface if the PGW/PCRF has requested H(e)NB information reporting and the MME/SGSN has received this information from H(e)NB in UE associated S1/Iu signalling (see 3GPP TS 23.139 [51]). The SGW shall forward this IE on S5/S8 interface if it is received from the MME/SGSN and the Modify Bearer Request message needs to be sent to the PGW as specified in the 3GPP TS 23.401 [3]; orthe Propagate BBAI information change flag is received from the MME/SGSN.(NOTE 7)"})
ies.append({ "ie_type" : "IP Address", "ie_value" : "MME/S4-SGSN Identifier", "presence" : "CO", "instance" : "2", "comment" : "If the PGW triggered SGW restoration procedure is supported, the MME/S4-SGSN shall include this IE on S11/S4 interface and the SGW shall forward this IE on S5 interface in the existing signalling as specified in 3GPP TS 23.007 [17].If the overload control feature is supported by the MME/S4-SGSN and is activated for the PLMN to which the PGW belongs(see clause 12.3.11), the MME/S4-SGSN shall include this IE on the S11/S4 interface during mobility procedures with MME/S4-SGSN change."})
ies.append({ "ie_type" : "CN Operator Selection Entity", "ie_value" : "CN Operator Selection Entity", "presence" : "CO", "instance" : "0", "comment" : "In shared networks, the SGSN shall include this IE on the S4 interface for the RAU procedure, if the information is available, and if the Serving Network IE is present in the message or if the CN Operator Selection Entity has changed, to indicate whether the Serving Network has been selected by the UE or by the network."})
ies.append({ "ie_type" : "Presence Reporting Area Information", "ie_value" : "Presence Reporting Area Information", "presence" : "CO", "instance" : "0", "comment" : "The MME/SGSN shall include this IE: -	if the PGW/PCRF/OCS has just requested to start or modify reporting changes of UE presence in a Presence Reporting Area and the MME/SGSN supports such reporting. The MME/SGSN shall then indicate whether the UE is inside or outside the newly started or modified Presence Reporting Area(s), or indicate the Presence Reporting Area(s) is inactive. Several IEs with the same type and instance value may be included as necessary to represent a list of Presence Reporting Area Information. One IE shall be included for each Presence Reporting Area newly started or modified.The MME/SGSN shall also include this IE in the following procedures, if the PGW/PCRF requested to report changes of UE presence in a Presence Reporting Area and the MME/SGSN supports such reporting: -	TAU/RAU/Handover procedures without SGW change and with MME/SGSN change and S1-based handover procedure with SGW change.  The MME/SGSN shall then indicate whether the UE is inside or outside the Presence Reporting Area(s) for each of the active Presence Reporting Area(s), or indicate that the Presence Reporting Area(s) is inactive. Several IEs with the same type and instance value may be included as necessary to represent a list of Presence Reporting Area Information.-	TAU/RAU/Handover/Cell Update procedures without MME/SGSN change, UE initiated Connection Resume and UE-initiated Service Request procedure if the UE enters or leaves the Presence Reporting Area(s). Several IEs with the same type and instance value may be included as necessary to represent a list of Presence Reporting Area Information. One IE shall be included for each active Presence Reporting Area that the UE has newly entered or left. See NOTE 5, NOTE 10.-	UE initiated Service Request, if ISR is active; See NOTE 22."})
ies.append({ "ie_type" : "Overload Control Information", "ie_value" : "MME/S4-SGSN's Overload Control Information", "presence" : "O", "instance" : "0", "comment" : "During an overload condition, the MME/S4-SGSN may include this IE on the S11/S4 interface if the overload control feature is supported by the MME/S4-SGSN and is activated for the PLMN to which the PGW belongs (see clause 12.3.11).When present, the MME/S4-SGSN shall provide only one instance of this IE, representing its overload information."})
ies.append({ "ie_type" : "Overload Control Information", "ie_value" : "SGW's Overload Control Information", "presence" : "O", "instance" : "1", "comment" : "During an overload condition, the SGW may include this IE over the S5/S8 interface if the overload control feature is supported by the SGW and is activated for the PLMN to which the PGW belongs (see clause 12.3.11).When present, the SGW shall provide only one instance of this IE, representing its overload information."})
ies.append({ "ie_type" : "Overload Control Information", "ie_value" : "ePDG's Overload Control Information", "presence" : "O", "instance" : "2", "comment" : "During an overload condition, the ePDG may include this IE over the S2b interface if the overload control feature is supported by the ePDG and is activated for the PLMN to which the PGW belongs (see clause 12.3.11).When present, the ePDG shall provide only one instance of this IE, representing its overload information."})
ies.append({ "ie_type" : "Serving PLMN Rate Control", "ie_value" : "Serving PLMN Rate Control", "presence" : "CO", "instance" : "0", "comment" : "The MME shall include this IE on the S11 interface if the Serving PLMN Rate is changed.The target MME shall also include this IE on the S11 interface during an Inter-MME mobility procedure if the Serving PLMN Rate control is configured, and if the configured value is different from the one received from the old MME. See NOTE 20.The SGW shall include this IE on S5/S8 if it receives this IE from MME via the Create Session Request or the Modify Bearer Request message.  "})
ies.append({ "ie_type" : "Counter", "ie_value" : "MO Exception Data Counter", "presence" : "CO", "instance" : "0", "comment" : "The MME shall include this IE on the S11 interface when it needs to send a non-zero counter value for the MO Exception Data Counter. The timestamp in the counter shall be set with the time at which the counter value increased from 0 to 1."})
ies.append({ "ie_type" : "IMSI", "ie_value" : "IMSI", "presence" : "O", "instance" : "0", "comment" : "The MME/SGSN should include the IMSI if available. See NOTE 23."})
ies.append({ "ie_type" : "ULI", "ie_value" : "User Location Information for SGW ", "presence" : "CO", "instance" : "1", "comment" : "The MME/SGSN shall include this IE on the S11/S4 interface, based on operator policy for the User Location Information to be sent to the SGW, if the user location information to be passed to the SGW is not already reported in the ULI IE in this message.When present, this IE shall include the ECGI, TAI, eNodeB ID, RAI and/or RNC-ID, based on local policy.See NOTE 25."})
ies.append({ "ie_type" : "TWAN Identifier", "ie_value" : "WLAN Location Information", "presence" : "CO", "instance" : "0", "comment" : "This IE shall be included on the S2b interface, during a UE initiated IPsec tunnel update procedure, if the WLAN Location Information is available. "})
ies.append({ "ie_type" : "TWAN Identifier Timestamp", "ie_value" : "WLAN Location Timestamp", "presence" : "CO", "instance" : "0", "comment" : "This IE shall be included on the S2b interface, during a UE initiated IPsec tunnel update procedure, if the WLAN Location Timestamp is available. "})
ies.append({ "ie_type" : "Secondary RAT Usage Data Report", "ie_value" : "Secondary RAT Usage Data Report", "presence" : "CO", "instance" : "0", "comment" : "If the PLMN has configured secondary RAT usage reporting, the MME shall include this IE on the S11 interface if it has received Secondary RAT usage data from eNodeB in an X2-based handover without Serving GW relocation, S1-based handover without MME or SGW relocation, or E-UTRAN initiated E-RAB modification procedure. The MME shall also include this IE on the S11 interface if it has received a Secondary RAT Usage Data Report from the source MME in an S1-based handover with MME relocation procedure.For S1-based handover with SGW relocation, the MME shall also set the IRSGW flag to 0, to indicate that the Secondary RAT usage data is reported for the Source SGW, and sent via the Target SGW to the PGW.Several IEs with the same type and instance value may be included, to represent multiple usage data reports."})
msg_list[key]["ies"] = ies
